/*
 * NotifyApplicationAvailableReceivingServlet.java
 *
 * Created on August 25, 2003, 4:05 PM
 */

package gov.grants.webSvcs.servlet.receiver;


import javax.xml.soap.*;
import javax.xml.messaging.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.xml.transform.*;
import javax.naming.*;

import java.io.InputStream;

// jwsdp - sun
import gov.grants.system.GrantSubmissionFooter;
import org.w3c.dom.Document;
import org.w3c.dom.DocumentFragment;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.xml.sax.SAXException;
import javax.xml.parsers.DocumentBuilder;
import gov.grants.system.GrantSubmissionFooter;
import javax.xml.parsers.DocumentBuilderFactory;

// Grants.gov
import gov.grants.utility.GrantsGovConstantsUtils;
import gov.grants.utility.GrantsGovConstants;
import gov.grants.webSvcs.utility.GrantsGovWebSvcsMediator;
import gov.grants.webSvcs.utility.GrantsGovWebSvcsMediatorStub;
import gov.grants.webSvcs.valueobject.*;
import gov.grants.webSvcs.utility.*;
import gov.grants.system.GrantSubmissionFooter;
import gov.grants.system.GrantSubmissionHeader;

/**
 *
 * @author  david.xia (dxia@att.com)
 * modified by mark sommer 9/8/03
 */
public class NotifyApplicationAvailableReceivingServlet extends JAXMServlet implements OnewayListener{

    /** Creates a new instance of NotifyApplicationAvailableReceivingServlet */
    public NotifyApplicationAvailableReceivingServlet() {
             System.out.println( "Construct Receiving Servlet " );
    }
    public void init(ServletConfig servletConfig)
        throws ServletException {
            // Be sure to call the superclass method
            super.init(servletConfig);

    }
    public void onMessage(javax.xml.soap.SOAPMessage requestMessage) {
        System.out.println("On message called in receiving servlet");

        try {
                System.out.println( "Here's the request message: " );
                requestMessage.writeTo(System.out);

                retrieveApplicationInformation(requestMessage);

        } catch(Exception e) {
            System.out.println("Error in processing or replying to a message:  " + e);

        }
    }

//   public ApplicationInformation retrieveApplicationInformation(SOAPMessage requestMsg)
   public void retrieveApplicationInformation(SOAPMessage requestMsg)
	throws javax.xml.soap.SOAPException, org.xml.sax.SAXException, java.io.IOException {

 	System.out.println( "Retreiving Application Information" );

        ApplicationInformation applicationInformation = null;
        String status;

        SOAPPart soapPart;
        SOAPEnvelope soapEnvelope;
        SOAPBody soapBody;
        SOAPElement rootElement;
        SOAPElement footer;
        SOAPElement header;

        javax.xml.soap.Name functionName;
        javax.xml.soap.Name applicationNumberName;
        javax.xml.soap.Name applicationInformationName;

        soapPart =requestMsg.getSOAPPart();
        soapEnvelope = soapPart.getEnvelope();
        soapBody = soapEnvelope.getBody();


        // Search for Function name
        functionName = soapEnvelope.createName("NotifyApplicationAvailable", GrantsGovConstants.AGIS_PREFIX, GrantsGovConstants.AGIS_URI );
        applicationInformationName = soapEnvelope.createName("ApplicationInformation");

        java.util.Iterator valueRequests = soapBody.getChildElements(functionName);

        /*
        //get available applicatin number
        rootElement = (SOAPElement)valueRequests.next();
        java.util.Iterator applicationInformationIterator = rootElement.getChildElements(applicationInformationName);

        GrantSubmissionHeader newHeader;
        GrantSubmissionFooter newFooter;
        SOAPElement param;


        //get application information
        if (applicationInformationIterator.hasNext()){
            param = (SOAPElement)(applicationInformationIterator.next());
            header = (SOAPElement)(param.getChildElements(soapEnvelope.createName("GrantSubmissionHeader")).next());
            footer = (SOAPElement)(param.getChildElements(soapEnvelope.createName("GrantSubmissionFooter")).next());

            applicationInformation = new ApplicationInformation();
            newHeader = applicationInformation.getGrantSubmissionHeader();
            newFooter = applicationInformation.getGrantSubmissionFooter();

            if ((header.getChildElements(soapEnvelope.createName("AgencyName"))).hasNext()){
                newHeader.setAgencyName(((SOAPElement)header.getChildElements(soapEnvelope.createName("AgencyName")).next()).getValue());
            }
            if ((header.getChildElements(soapEnvelope.createName("CFDANumber"))).hasNext()){
                newHeader.setCFDANumber(((SOAPElement)header.getChildElements(soapEnvelope.createName("CFDANumber")).next()).getValue());
            }
            if ((header.getChildElements(soapEnvelope.createName("ActivityTitle"))).hasNext()){
                 newHeader.setActivityTitle(((SOAPElement)header.getChildElements(soapEnvelope.createName("ActivityTitle")).next()).getValue());
            }
            if ((header.getChildElements(soapEnvelope.createName("opportunityID"))).hasNext()){
 //               newHeader.setOpportunityID(((SOAPElement)header.getChildElements(soapEnvelope.createName("opportunityID")).next()).getValue());
           }
           if ((header.getChildElements(soapEnvelope.createName("OpportunityTitle"))).hasNext()){
                newHeader.setOpportunityTitle(((SOAPElement)header.getChildElements(soapEnvelope.createName("OpportunityTitle")).next()).getValue());
           }
  //         if ((header.getChildElements(soapEnvelope.createName("CompetitionID"))).hasNext()){
   //            newHeader.setCompetitionID(((SOAPElement)header.getChildElements(soapEnvelope.createName("CompetitionID")).next()).getValue());
    //   }
			if ((header.getChildElements(soapEnvelope.createName("SubmissionTitle"))).hasNext()){
				newHeader.setSubmissionTitle(((SOAPElement)header.getChildElements(soapEnvelope.createName("SubmissionTitle")).next()).getValue());
			}

//            applicationInformation.getGrantSubmissionHeader().setOpeningDate(((SOAPElement)header.getChildElements(soapEnvelope.createName("OpeningDate")).next()).getValue());
//            applicationInformation.getGrantSubmissionHeader().setClosingDate(((SOAPElement)header.getChildElements(soapEnvelope.createName("ClosingDate")).next()).getValue());



			if ( (footer.getChildElements(soapEnvelope.createName("SubmitterName"))).hasNext()) {
				newFooter.setSubmitterName(((SOAPElement)footer.getChildElements(soapEnvelope.createName("SubmitterName")).next()).getValue());
			}

			if ( (footer.getChildElements(soapEnvelope.createName("Grants_govTrackingNumber"))).hasNext()){
				newFooter.setGrantsGovTrackingNumber(((SOAPElement)footer.getChildElements(soapEnvelope.createName("Grants_govTrackingNumber")).next()).getValue());
			}

//          applicationInformation.getGrantSubmissionFooter().setReceivedDateTime(((SOAPElement)footer.getChildElements(soapEnvelope.createName("ReceivedDateTime")).next()).getValue());

			status = ((SOAPElement)(param.getChildElements(soapEnvelope.createName("Status")).next())).getValue();
			applicationInformation.setStatus(status);

       }


        return applicationInformation;
         */

    }
}
