/*
 * $Id: NotifyApplicationAvailableSendingServlet.java,v 1.5 2003/09/09 22:20:27 grantsuser Exp $
 * $Revision: 1.5 $
 * $Date: 2003/09/09 22:20:27 $
 * David Xia (Dxia@att.com)
 * modified by mark sommer 9/8/03
 */

package gov.grants.webSvcs.servlet.sender;

// sun
import java.net.*;
import java.io.*;
import java.util.*;

import javax.servlet.http.*;
import javax.servlet.*;

import javax.xml.soap.*;

import javax.activation.*;
import javax.naming.*;

import gov.grants.webSvcs.valueobject.ApplicationInformation;
import gov.grants.system.*;
import gov.grants.webSvcs.utility.GrantsGovWebSvcsMediatorStub;
import gov.grants.utility.GrantsGovConstants;

public class NotifyApplicationAvailableSendingServlet extends HttpServlet {

//    String recipient = null;
    String attachmentData = null;
    ServletContext servletContext;
	private RequestDispatcher rd;

    // Connection to send messages.
    private SOAPConnection con;

    public void init(ServletConfig servletConfig) throws ServletException {
        super.init( servletConfig );
        servletContext = servletConfig.getServletContext();

        try {
		SOAPConnectionFactory scf = SOAPConnectionFactory.newInstance();
                con = scf.createConnection();
        } catch(Exception e) {
            System.out.println("Unable to open a SOAPConnection" + e);
        }

//        InputStream in = servletContext.getResourceAsStream("/WEB-INF/application.properties");

//        if ( in != null ) {
//            Properties props = new Properties();
//
//            try {
//                    props.load(in);
//                    recipient = props.getProperty("NotifyApplicationAvailableRecipient");
//                    System.out.println( "RECIPIENT has been loaded from properties file, and is set to " + recipient );
//            } catch (IOException ex) {
                // Ignore
//            }
//        }
    }

    public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException,ServletException	{
		doPost( request, response );
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response )
                throws IOException,ServletException{

        	//Retrieve recipient address
        	String recipient = request.getParameter( "recipient" );
        	System.out.println( "RECIPIENT has been received from JSP request, and is set to " + recipient );

            try{
                SOAPMessage notifyMessage = createNotifyMessage();


                StringBuffer urlSB = new StringBuffer();
                urlSB.append(request.getScheme()).append("://").append(request.getServerName());
                urlSB.append( ":" ).append( request.getServerPort() ).append( request.getContextPath() );
                String requestBase=urlSB.toString();

                System.out.println( "requestBase = " + requestBase );

                // Create an endpoint for the recipient of the message.
                if( recipient == null ) {
                    recipient=requestBase + "/AgencyIntegration/NotifyApplicationAvailable";
                    System.out.println( "NotifyApplicationAvailable recipient was null: Has been set to " + recipient );
                }

                URL urlEndpoint = new URL(recipient);

                // Send the message to the provider using the connection.
                System.out.println( "sending NotifyApplicationAvailable." );

                SOAPMessage reply = con.call(notifyMessage, urlEndpoint);
                 System.out.println( "sent NotifyApplicationAvailable" );

        } catch(Throwable e) {
            e.printStackTrace();
            System.out.println("Error in constructing or sending message " + e.getMessage());

			request.setAttribute( "ErrorMsg", e.getMessage() );

			System.out.println( "About to forward to /xmlToDB/jsp/include/xmlToDBErrorPage.jsp" );
			rd = request.getRequestDispatcher("/xmlToDB/jsp/include/xmlToDBErrorPage.jsp");
			rd.forward(request, response);
			return;
        } finally {
			; // cleanup here
		}

		System.out.println( "About to forward to /webSvcs/jsp/NotifyWebSvc.jsp" );
		rd = request.getRequestDispatcher("/webSvcs/jsp/NotifyWebSvc.jsp?success=True");
		rd.forward(request, response);

        }


        public SOAPMessage createNotifyMessage() throws Exception{
            GrantsGovWebSvcsMediatorStub grantsGovWebSvcsMediator = new GrantsGovWebSvcsMediatorStub( servletContext );
//            ApplicationInformation applicationInformation = grantsGovWebSvcsMediator.getAvailableApplication();

            MessageFactory messageFactory = MessageFactory.newInstance();

            System.out.println( "In create ResponseMsg" );
            SOAPMessage responseMsg = messageFactory.createMessage();
            SOAPEnvelope soapEnvelope = responseMsg.getSOAPPart().getEnvelope();
            SOAPBody responseBody = soapEnvelope.getBody();
            SOAPElement rootElement = responseBody.addChildElement(soapEnvelope.createName( "NotifyApplicationAvailable", GrantsGovConstants.AGIS_PREFIX, GrantsGovConstants.AGIS_URI ));
            rootElement.addTextNode("New Grant Application Available");
  /*          SOAPElement applicationInformationElement;
            SOAPElement headerElement;
            SOAPElement footerElement;
            SOAPElement statusElement;
            SOAPElement paramElement;
            GrantSubmissionFooter footer;
            GrantSubmissionHeader header;


            footer = applicationInformation.getGrantSubmissionFooter();
            header = applicationInformation.getGrantSubmissionHeader();
            applicationInformationElement = rootElement.addChildElement(soapEnvelope.createName("ApplicationInformation"));
            headerElement = applicationInformationElement.addChildElement(soapEnvelope.createName("GrantSubmissionHeader"));
            footerElement = applicationInformationElement.addChildElement(soapEnvelope.createName("GrantSubmissionFooter"));
            statusElement = applicationInformationElement.addChildElement(soapEnvelope.createName("Status"));
            statusElement.addTextNode(applicationInformation.getStatus());


            //add header info
            //Since hash value is not really meanful in getting application list, we comment it out here
            //addNotNullElement(headElement, "HashValue", header.getHashValue());
            addNotNullElement(headerElement, "AgencyName", header.getAgencyName());
            addNotNullElement(headerElement, "CFDANumber", header.getCFDANumber());
            addNotNullElement(headerElement, "ActivityTitle", header.getActivityTitle());
            addNotNullElement(headerElement, "opportunityID", header.getOpportunityID());
            addNotNullElement(headerElement, "OpportunityTitle", header.getOpportunityTitle());
            addNotNullElement(headerElement, "CompetitionID", header.getCompetitionID());
        //    addNotNullElement(headerElement, "OpeningDate", header.getOpeningDate());
      //      addNotNullElement(headerElement, "ClosingDate", header.getClosingDate());
            addNotNullElement(headerElement, "SubmissionTitle", header.getSubmissionTitle());

            //add footer info
            //Since hash value is not really meanful in getting application list, we comment it out here
            //addNotNullElement(footerElement, "HashValue", footer.getHashValue());
     //       addNotNullElement(footerElement, "ReceivedDateTime", footer.getReceivedDateTime());
            addNotNullElement(footerElement, "Submitternme", footer.getSubmitterName());
            addNotNullElement(footerElement, "Grants_govTrackingNumber", footer.getGrantsGovTrackingNumber());

*/
            FileOutputStream sentFile = new FileOutputStream("NotifyAvailableApplication.txt");
            responseMsg.writeTo(sentFile);
            sentFile.close();
            return responseMsg;
        }


        public void addNotNullElement (SOAPElement parentElement, String elementName, Object object)
        throws SOAPException {
            SOAPElement childElement;
            if (object != null)
            {
                childElement = parentElement.addChildElement(elementName);
                childElement.addTextNode(object.toString());

                System.out.println( elementName + " = " + object.toString() );
            }
        }



}

